
#include "kmathareaperimeter_part.h"

#include <kinstance.h>

#include "areaperimeter1.h"

KMathAreaPerimeterPart::KMathAreaPerimeterPart( QWidget *parentWidget, const char *widgetName,
                                  QObject *parent, const char *name )
    : KParts::ReadOnlyPart(parent, name)
{
    setInstance( KMathAreaPerimeterPartFactory::instance() );

    m_widget = new AreaPerimeter1( parentWidget, widgetName );

    setWidget(m_widget);

    setXMLFile("kmathareaperimeter_part.rc");
}

KMathAreaPerimeterPart::~KMathAreaPerimeterPart()
{
}


bool KMathAreaPerimeterPart::openFile()
{
    return false;
}


// It's usually safe to leave the factory code alone.. with the
// notable exception of the KAboutData data
#include <kaboutdata.h>
#include <klocale.h>

KInstance*  KMathAreaPerimeterPartFactory::s_instance = 0L;
KAboutData* KMathAreaPerimeterPartFactory::s_about = 0L;

KMathAreaPerimeterPartFactory::KMathAreaPerimeterPartFactory()
    : KParts::Factory()
{
}

KMathAreaPerimeterPartFactory::~KMathAreaPerimeterPartFactory()
{
    delete s_instance;
    delete s_about;

    s_instance = 0L;
}

KParts::Part* KMathAreaPerimeterPartFactory::createPartObject( QWidget *parentWidget, const char *widgetName,
                                                        QObject *parent, const char *name,
                                                        const char *classname, const QStringList &args )
{
    // Create an instance of our Part
    KMathAreaPerimeterPart* obj = new KMathAreaPerimeterPart( parentWidget, widgetName, parent, name );
    return obj;
}

KInstance* KMathAreaPerimeterPartFactory::instance()
{
    if( !s_instance )
    {
        s_about = new KAboutData("kmathareaperimeterpart", I18N_NOOP("KMathAreaPerimeterPart"), "0.3");
        s_about->addAuthor("Trenton Carr", 0, "trentoncarr@telkomsa.net");
        s_instance = new KInstance(s_about);
    }
    return s_instance;
}

extern "C"
{
    void* init_libkmathareaperimeterpart()
    {
        return new KMathAreaPerimeterPartFactory;
    }
};

#include "kmathareaperimeter_part.moc"
