
#include "kmathfactor_part.h"

#include <kinstance.h>

#include "factors.h"

KMathFactorPart::KMathFactorPart( QWidget *parentWidget, const char *widgetName,
                                  QObject *parent, const char *name )
    : KParts::ReadOnlyPart(parent, name)
{

    setInstance( KMathFactorPartFactory::instance() );

    m_widget = new Factors( parentWidget, widgetName );

    setWidget(m_widget);

    setXMLFile("kmathfactor_part.rc");
}

KMathFactorPart::~KMathFactorPart()
{
}

bool KMathFactorPart::openFile()
{
    return false;
}

// It's usually safe to leave the factory code alone.. with the
// notable exception of the KAboutData data
#include <kaboutdata.h>
#include <klocale.h>

KInstance*  KMathFactorPartFactory::s_instance = 0L;
KAboutData* KMathFactorPartFactory::s_about = 0L;

KMathFactorPartFactory::KMathFactorPartFactory()
    : KParts::Factory()
{
}

KMathFactorPartFactory::~KMathFactorPartFactory()
{
    delete s_instance;
    delete s_about;

    s_instance = 0L;
}

KParts::Part* KMathFactorPartFactory::createPartObject( QWidget *parentWidget, const char *widgetName,
                                                        QObject *parent, const char *name,
                                                        const char *classname, const QStringList &args )
{
    // Create an instance of our Part
    KMathFactorPart* obj = new KMathFactorPart( parentWidget, widgetName, parent, name );
    return obj;
}

KInstance* KMathFactorPartFactory::instance()
{
    if( !s_instance )
    {
        s_about = new KAboutData("kmathfactorpart", I18N_NOOP("KMathFactorPart"), "0.3");
        s_about->addAuthor("Trenton Carr", 0, "trentoncarr@telkomsa.net");
        s_instance = new KInstance(s_about);
    }
    return s_instance;
}

extern "C"
{
    void* init_libkmathfactorpart()
    {
        return new KMathFactorPartFactory;
    }
};

#include "kmathfactor_part.moc"
