
#ifndef _KMATHFACTORPART_H_
#define _KMATHFACTORPART_H_

#include <kparts/part.h>
#include <kparts/factory.h>

class QWidget;
class QPainter;
class KURL;

class Factors;

/**
 * @author Trenton Carr <trentoncarr@telkomsa.net>
 * @version 0.3
 */
class KMathFactorPart : public KParts::ReadOnlyPart
{
    Q_OBJECT
public:
    /**
     * Default constructor
     */
    KMathFactorPart(QWidget *parentWidget, const char *widgetName,
                    QObject *parent, const char *name);

    virtual ~KMathFactorPart();

protected:
    virtual bool openFile();

private:
    Factors *m_widget;
};

class KInstance;
class KAboutData;

class KMathFactorPartFactory : public KParts::Factory
{
    Q_OBJECT
public:
    KMathFactorPartFactory();
    virtual ~KMathFactorPartFactory();
    virtual KParts::Part* createPartObject( QWidget *parentWidget, const char *widgetName,
                                            QObject *parent, const char *name,
                                            const char *classname, const QStringList &args );
    static KInstance* instance();

private:
    static KInstance* s_instance;
    static KAboutData* s_about;
};

#endif // _KMATHFACTORPART_H_
