
#include "kmathline_part.h"

#include <kinstance.h>

#include "lines.h"

KMathLinePart::KMathLinePart( QWidget *parentWidget, const char *widgetName,
                                  QObject *parent, const char *name )
    : KParts::ReadOnlyPart(parent, name)
{
    setInstance( KMathLinePartFactory::instance() );

    m_widget = new Lines( parentWidget, widgetName );

    setWidget(m_widget);

    setXMLFile("kmathline_part.rc");
}

KMathLinePart::~KMathLinePart()
{
}

bool KMathLinePart::openFile()
{
    return false;
}

// It's usually safe to leave the factory code alone.. with the
// notable exception of the KAboutData data
#include <kaboutdata.h>
#include <klocale.h>

KInstance*  KMathLinePartFactory::s_instance = 0L;
KAboutData* KMathLinePartFactory::s_about = 0L;

KMathLinePartFactory::KMathLinePartFactory()
    : KParts::Factory()
{
}

KMathLinePartFactory::~KMathLinePartFactory()
{
    delete s_instance;
    delete s_about;

    s_instance = 0L;
}

KParts::Part* KMathLinePartFactory::createPartObject( QWidget *parentWidget, const char *widgetName,
                                                        QObject *parent, const char *name,
                                                        const char *classname, const QStringList &args )
{
    // Create an instance of our Part
    KMathLinePart* obj = new KMathLinePart( parentWidget, widgetName, parent, name );
    return obj;
}

KInstance* KMathLinePartFactory::instance()
{
    if( !s_instance )
    {
        s_about = new KAboutData("kmathlinepart", I18N_NOOP("KMathLinePart"), "0.3");
        s_about->addAuthor("Trenton Carr", 0, "trentoncarr@telkomsa.net");
        s_instance = new KInstance(s_about);
    }
    return s_instance;
}

extern "C"
{
    void* init_libkmathlinepart()
    {
        return new KMathLinePartFactory;
    }
};

#include "kmathline_part.moc"
