
#ifndef _KMATHLINEPART_H_
#define _KMATHLINEPART_H_

#include <kparts/part.h>
#include <kparts/factory.h>

class QWidget;
class QPainter;
class KURL;

class Lines;

/**
 * @author Trenton Carr <trentoncarr@telkomsa.net>
 * @version 0.3
 */
class KMathLinePart : public KParts::ReadOnlyPart
{
    Q_OBJECT
public:
    KMathLinePart(QWidget *parentWidget, const char *widgetName,
                    QObject *parent, const char *name);
    virtual ~KMathLinePart();

protected:
    virtual bool openFile();

private:
    Lines *m_widget;
};

class KInstance;
class KAboutData;

class KMathLinePartFactory : public KParts::Factory
{
    Q_OBJECT
public:
    KMathLinePartFactory();
    virtual ~KMathLinePartFactory();
    virtual KParts::Part* createPartObject( QWidget *parentWidget, const char *widgetName,
                                            QObject *parent, const char *name,
                                            const char *classname, const QStringList &args );
    static KInstance* instance();
 
private:
    static KInstance* s_instance;
    static KAboutData* s_about;
};

#endif // _KMATHLINEPART_H_
