/***************************************************************************
                          lines.cpp  -  description
                             -------------------
    begin                : Son Apr 14 2002
    copyright            : (C) 2002 by Birgit Schulz
    email                : B.Schulz@Superlehrer.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "lines.h"
#include "lines.moc"

#include <knuminput.h>
#include <kpushbutton.h>
#include <ktextbrowser.h>
#include <klocale.h>
#include <kapplication.h>

#include <qlabel.h>
#include <qstring.h>

Lines::Lines(QWidget *parent, const char *name ) : LinesD(parent,name)
{
    TextLabelInformation->setText(i18n("Select a line Function below"));

    TextLabelFirstInfoPoint->hide();					//1st point frame
    kIntSpinBoxPoint1x->hide();
    textLabel3->hide();
    line5->hide();
    textLabel2->hide();
    kIntSpinBoxPoint1y->hide();
    textLabel4->hide();

    TextLabelSecondInfoPoint->hide();					//2nd point frame
    kIntSpinBoxPoint2x->hide();
    textLabel3_2->hide();
    line1->hide();
    textLabel2_2->hide();
    kIntSpinBoxPoint2y->hide();
    textLabel4_2->hide();

    textLabelFirtsInfoLine->hide();						//1st line frame
    kIntSpinBoxLine1mx->hide();
    textLabel6->hide();
    kIntSpinBoxLine1c->hide();
    textLabel5->hide();

    textLabelSecondInfoLine->hide();					//2nd line frame
    kIntSpinBoxLine2mx->hide();
    textLabel6_2->hide();
    kIntSpinBoxLine2c->hide();
    textLabel5_2->hide();

    textLabel1->hide();									//gradient frame
    kIntSpinBoxGradient->hide();
    textLabel8->hide();
    textLabel9->hide();
    line4->hide();
    textLabel9_2->hide();
    textLabel1_2->hide();


    KPushButtonCalculate->hide();						//button frame
    KPushButtonClear->hide();

    slotClear();
}

Lines::~Lines()
{}

void Lines::slotCalculate()
{
    switch (m_eSelected)
    {
    case TwoPoints: //2 Points
        {
            int x1, y1, x2, y2;
            QString qsResult, qsX1, qsY1, qsX2, qsY2, qsC, qsM, qsEquation;
            x1 = kIntSpinBoxPoint1x->value();
            y1 = kIntSpinBoxPoint1y->value();
            x2 = kIntSpinBoxPoint2x->value();
            y2 = kIntSpinBoxPoint2y->value();

            qsX1 = kIntSpinBoxPoint1x->text();
            qsY1 = kIntSpinBoxPoint1y->text();
            qsX2 = kIntSpinBoxPoint2x->text();
            qsY2 = kIntSpinBoxPoint2y->text();
            bool bSucess;
            double m = Gradient(x1, x2, y1, y2, bSucess);
            if (bSucess == false)
            {
                qsResult = i18n("The line, going through the given points, is vertical.\n");
                qsResult += i18n("So it is not a function and every point on this line has the property<p>x = ") + qsX1;
                KTextBrowserResult->setText(qsResult);
            }
            else
            {
                double c = AxisCut(m, x1, y1);
                qsM = qsM.number(m);
                qsC = qsC.number(c);
                qsResult = i18n("The equation of the line going through the given points is:<p>");
                if ( c == 0)
                {
                    qsEquation = "y = " + qsM + "x";
                    qsEquation = qsEquation.simplifyWhiteSpace();
                }
                else if (c > 0)
                {
                    qsEquation = "y = " + qsM + "x+" + qsC;
                    qsEquation = qsEquation.simplifyWhiteSpace();
                }
                else
                {
                    qsEquation = "y = " + qsM + "x" + qsC;
                    qsEquation = qsEquation.simplifyWhiteSpace();
                }

                KTextBrowserResult->setText(qsResult + qsEquation);
            }
            break;
        }

    case OnePoint: //1 Point and Gradient
        {
            int x1, y1, m;
            QString qsResult, qsX1, qsY1, qsC, qsM, qsEquation;
            x1 = kIntSpinBoxPoint1x->value();
            y1 = kIntSpinBoxPoint1y->value();
            m = kIntSpinBoxGradient->value();
            double c = AxisCut(m, x1, y1);
            qsX1 = kIntSpinBoxPoint1x->text();
            qsY1 = kIntSpinBoxPoint1y->text();
            qsC = qsC.number(c);
            qsM = kIntSpinBoxGradient->text();

            qsResult = i18n("The line, with the given gradient which is going through the given point , has got the equation:\n\n");
            if ( c == 0)

            {
                qsEquation += "y = " + qsM + "  x ";
                qsEquation = qsEquation.simplifyWhiteSpace();
            }
            else if (c > 0)
            {
                qsEquation += "y = " + qsM + "  x + " + qsC;
                qsEquation = qsEquation.simplifyWhiteSpace();
            }
            else
            {
                qsEquation += "y = " + qsM + "  x " + qsC;
                qsEquation = qsEquation.simplifyWhiteSpace();
            }
            KTextBrowserResult->setText(qsResult + qsEquation);
            break;
        }


    case AxisSection: //X and Y Axis Cuts
        {
            int m, c, ys;
            double xs;
            QString qsResult, qsEquation, qsXs, qsYs;
            m = kIntSpinBoxLine1mx->value();
            c = kIntSpinBoxLine1c->value();

            if (m == 0)
            {
                qsYs = qsYs.number(ys);
                qsResult = i18n("The line with the given equation is parallel to the x-axis, so it does not intersect it.<br>");
                qsResult += i18n("The y-axis is intersected at <p>S( 0 | ") + qsYs + " ).";
            }
            else
            {
                ys = c;
                xs = (-1.0)*c/m;
                qsXs = qsXs.number(xs);
                qsYs = qsYs.number(ys);
                qsResult = i18n("The given line crosses the <b>x-axis</b> at<br>");
                qsResult += " S<sub>x</sub>( " + qsXs + i18n(" | 0 ) and the <b>y-axis</b> at \n");
                qsResult += " S<sub>y</sub>( 0 | " + qsYs + " ).";
            }

            KTextBrowserResult->setText(qsResult);
            break;
        }

    case Section: //Intersect Point with two Lines
        {
            int m1, c1, m2, c2, xs, ys;
            QString qsResult, qsEquation, qsXs, qsYs;
            m1=kIntSpinBoxLine1mx->value();
            c1=kIntSpinBoxLine1c->value();
            m2=kIntSpinBoxLine2mx->value();
            c2=kIntSpinBoxLine2c->value();
            if ((m1 - m2) == 0)
            {
                if ((c1 - c2) == 0)
                {
                    qsResult = i18n("The two given lines are identical, so there is an infinite number of intersecting points.");
                }
                else
                {
                    qsResult = i18n("The two given lines are parallel, so there are no intersecting points.");
                }
            }
            else
            {
                xs = (c2 - c1)/(m1 - m2);
                ys = m1*xs + c1;
                qsXs = qsXs.number(xs);
                qsYs = qsYs.number(ys);
                qsResult = i18n("The point of intersection of the two given lines is<p>S( ") + qsXs + " | " + qsYs + " ).";
                qsResult = qsResult.simplifyWhiteSpace();
            }
            KTextBrowserResult->setText(qsResult);
            break;
        }
    }
}

void Lines::hideInput()
{
    TextLabelFirstInfoPoint->hide();					//1st point frame
    kIntSpinBoxPoint1x->hide();
    textLabel3->hide();
    line5->hide();
    textLabel2->hide();
    kIntSpinBoxPoint1y->hide();
    textLabel4->hide();

    TextLabelSecondInfoPoint->hide();					//2nd point frame
    kIntSpinBoxPoint2x->hide();
    textLabel3_2->hide();
    line1->hide();
    textLabel2_2->hide();
    kIntSpinBoxPoint2y->hide();
    textLabel4_2->hide();

    textLabelFirtsInfoLine->hide();						//1st line frame
    kIntSpinBoxLine1mx->hide();
    textLabel6->hide();
    kIntSpinBoxLine1c->hide();
    textLabel5->hide();

    textLabelSecondInfoLine->hide();					//2nd line frame
    kIntSpinBoxLine2mx->hide();
    textLabel6_2->hide();
    kIntSpinBoxLine2c->hide();
    textLabel5_2->hide();

    textLabel1->hide();									//gradient frame
    kIntSpinBoxGradient->hide();
    textLabel8->hide();
    textLabel9->hide();
    line4->hide();
    textLabel9_2->hide();
    textLabel1_2->hide();
}

void Lines::slotClear()
{
    kIntSpinBoxPoint1x->setValue( 0 );
    kIntSpinBoxPoint1y->setValue( 0 );
    kIntSpinBoxPoint2x->setValue( 0 );
    kIntSpinBoxPoint2y->setValue( 0 );
    kIntSpinBoxGradient->setValue( 0 );
    kIntSpinBoxLine1mx->setValue( 0 );
    kIntSpinBoxLine1c->setValue( 0 );
    kIntSpinBoxLine2mx->setValue( 0 );
    kIntSpinBoxLine2c->setValue( 0 );
    
    KTextBrowserResult->setText(i18n(""));
}

void Lines::slotShowLinesAxisSection()
{	
    slotClear();

    hideInput();

    TextLabelInformation->setText(i18n("Find intersection with axis"));

    KTextBrowserResult->setText("");

    textLabelFirtsInfoLine->show();						//1st line frame
    kIntSpinBoxLine1mx->show();
    textLabel6->show();
    kIntSpinBoxLine1c->show();
    textLabel5->show();

    KPushButtonCalculate->show();						//button frame
    KPushButtonClear->show();

    m_eSelected = AxisSection;
}

void Lines::slotShowLinesOnePoint()
{	
    slotClear();

    hideInput();

    KTextBrowserResult->setText("");

    TextLabelInformation->setText(i18n("Find equation with given point and gradient"));

    TextLabelFirstInfoPoint->show();					//Point frame
    kIntSpinBoxPoint1x->show();
    textLabel3->show();
    line5->show();
    textLabel2->show();
    kIntSpinBoxPoint1y->show();
    textLabel4->show();

    textLabel1->hide();									//gradient frame
    kIntSpinBoxGradient->hide();
    textLabel8->hide();
    textLabel9->hide();
    line4->hide();
    textLabel9_2->hide();
    textLabel1_2->hide();

    KPushButtonCalculate->show();						//button frame
    KPushButtonClear->show();

    m_eSelected = OnePoint;
}

void Lines::slotShowLinesTwoPoints()
{	
    slotClear();

    hideInput();

    TextLabelInformation->setText(i18n("Find equation with two given points"));

    KTextBrowserResult->setText("");

    TextLabelFirstInfoPoint->show();					//1st point frame
    kIntSpinBoxPoint1x->show();
    textLabel3->show();
    line5->show();
    textLabel2->show();
    kIntSpinBoxPoint1y->show();
    textLabel4->show();

    TextLabelSecondInfoPoint->show();					//2nd point frame
    kIntSpinBoxPoint2x->show();
    textLabel3_2->show();
    line1->show();
    textLabel2_2->show();
    kIntSpinBoxPoint2y->show();
    textLabel4_2->show();

    KPushButtonCalculate->show();						//button frame
    KPushButtonClear->show();

    m_eSelected = TwoPoints;
}


void Lines::slotShowLinesSection()
{	//Empty result box
    slotClear();

    hideInput();

    KTextBrowserResult->setText("");

    TextLabelInformation->setText(i18n("Find intersect-point of two lines"));

    textLabelFirtsInfoLine->show();						//1st line frame
    kIntSpinBoxLine1mx->show();
    textLabel6->show();
    kIntSpinBoxLine1c->show();
    textLabel5->show();

    textLabelSecondInfoLine->show();					//2nd line frame
    kIntSpinBoxLine2mx->show();
    textLabel6_2->show();
    kIntSpinBoxLine2c->show();
    textLabel5_2->show();

    KPushButtonCalculate->show();						// button frame
    KPushButtonClear->show();	

    m_eSelected = Section;
}

double Lines::Gradient(double x1, double x2, double y1, double y2, bool &bSucess)
{
    if ((x1 - x2) == 0)
    {
        bSucess = false;
        return 0;
    }
    else
    {
        bSucess = true;
        double m = (y1 - y2)/(x1 - x2);
        return m;
    }
}

double Lines::AxisCut(double m, double x1, double y1)
{
    double c = y1 - m*x1;
    return c;
}
