
#include "kmathparabola_part.h"

#include <kinstance.h>

#include "parabolas.h"

KMathParabolaPart::KMathParabolaPart( QWidget *parentWidget, const char *widgetName,
                                  QObject *parent, const char *name )
    : KParts::ReadOnlyPart(parent, name)
{
    setInstance( KMathParabolaPartFactory::instance() );

    m_widget = new Parabolas( parentWidget, widgetName );

    setWidget(m_widget);

    setXMLFile("kmathparabola_part.rc");
}

KMathParabolaPart::~KMathParabolaPart()
{
}

bool KMathParabolaPart::openFile()
{
    return false;
}

// It's usually safe to leave the factory code alone.. with the
// notable exception of the KAboutData data
#include <kaboutdata.h>
#include <klocale.h>

KInstance*  KMathParabolaPartFactory::s_instance = 0L;
KAboutData* KMathParabolaPartFactory::s_about = 0L;

KMathParabolaPartFactory::KMathParabolaPartFactory()
    : KParts::Factory()
{
}

KMathParabolaPartFactory::~KMathParabolaPartFactory()
{
    delete s_instance;
    delete s_about;

    s_instance = 0L;
}

KParts::Part* KMathParabolaPartFactory::createPartObject( QWidget *parentWidget, const char *widgetName,
                                                        QObject *parent, const char *name,
                                                        const char *classname, const QStringList &args )
{
    // Create an instance of our Part
    KMathParabolaPart* obj = new KMathParabolaPart( parentWidget, widgetName, parent, name );
    return obj;
}

KInstance* KMathParabolaPartFactory::instance()
{
    if( !s_instance )
    {
        s_about = new KAboutData("kmathparabolapart", I18N_NOOP("KMathParabolaPart"), "0.3");
        s_about->addAuthor("Trenton Carr", 0, "trentoncarr@telkomsa.net");
        s_instance = new KInstance(s_about);
    }
    return s_instance;
}

extern "C"
{
    void* init_libkmathparabolapart()
    {
        return new KMathParabolaPartFactory;
    }
};

#include "kmathparabola_part.moc"
