
#ifndef _KMATHPARABOLAPART_H_
#define _KMATHPARABOLAPART_H_

#include <kparts/part.h>
#include <kparts/factory.h>

class QWidget;
class QPainter;
class KURL;

class Parabolas;

/**
 * @author Trenton Carr <trentoncarr@telkomsa.net>
 * @version 0.3
 */
class KMathParabolaPart : public KParts::ReadOnlyPart
{
    Q_OBJECT
public:
    KMathParabolaPart(QWidget *parentWidget, const char *widgetName,
                    QObject *parent, const char *name);

    virtual ~KMathParabolaPart();

protected:
    virtual bool openFile();

private:
    Parabolas *m_widget;
};

class KInstance;
class KAboutData;

class KMathParabolaPartFactory : public KParts::Factory
{
    Q_OBJECT
public:
    KMathParabolaPartFactory();
    virtual ~KMathParabolaPartFactory();
    virtual KParts::Part* createPartObject( QWidget *parentWidget, const char *widgetName,
                                            QObject *parent, const char *name,
                                            const char *classname, const QStringList &args );
    static KInstance* instance();
 
private:
    static KInstance* s_instance;
    static KAboutData* s_about;
};

#endif // _KMATHPARABOLAPART_H_
