/***************************************************************************
                          parabolas.cpp  -  description
                             -------------------
    begin                : Sam Mai 4 2002
    copyright            : (C) 2002 by Birgit Schulz
    email                : B.Schulz@Superlehrer.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "parabolas.h"
#include "parabolas.moc"


#include <math.h>
#include <knuminput.h>
#include <krestrictedline.h>
#include <kpushbutton.h>
#include <ktextbrowser.h>
#include <klocale.h>
#include <kapplication.h>

#include <qlabel.h>
#include <qstring.h>

Parabolas::Parabolas(QWidget *parent, const char *name ) : ParabolasD(parent,name)
{
    TextLabelInformation->setText(i18n("Choose a function from the Icons below"));


    Point1_x->hide();
    Point1_y->hide();
    Point2_x->hide();
    Point2_y->hide();
    Point3_x->hide();
    Point3_y->hide();
    Line_mx->hide();
    Line_c->hide();
    parabola_mx->hide();
    parabola_bx->hide();
    parabola_c->hide();
    parabola2_mx->hide();
    parabola2_bx->hide();
    parabola2_c->hide();

    point1->hide();
    textLabel3->hide();
    textLabel2->hide();
    pointformat1->hide();
    point2->hide();
    textLabel3_2->hide();
    textLabel2_2->hide();
    pointformat2->hide();
    point3->hide();
    textLabel3_2_2->hide();
    textLabel2_3->hide();
    pointformat3->hide();
    lineEquation->hide();
    textLabel6->hide();
    lineFormat->hide();
    parabolaEquation1->hide();
    x1->hide();
    X1->hide();
    parabolaEquation2->hide();
    x2->hide();
    X2->hide();
    parabolaFormat->hide();
}

Parabolas::~Parabolas()
{}



void Parabolas::slotCalculate()
{
    switch (m_eSelected)
    {
    case TurnPoint: //Find the turnPoint of the given parabola
        {
            double a, b, c;
            QString qsResult, qsYs, qsXs;

            a = parabola_mx->value();
            b = parabola_bx->value();
            c = parabola_c->value();


            if (a == 0)
            {
                qsResult = "The given equation is <b>not the equation of a parabola</b>! So the vertex can't be found";

            }
            else
            {
                qsXs = "";
                qsYs = "";
                double xs = b / (-2.0*a);
                double ys = c-b*b/(4.0*a);
                qsXs = qsXs.number(xs);
                qsYs = qsYs.number(ys);
                qsResult = "The vertex of the given Parabola is <b>S(" + qsXs + "|" + qsYs + ")</b>.";


            }
            KTextBrowserResult->setText(qsResult);

            break;
        }

    case AxisSection: //Find the X and Y axis cuts from parabola equation
        {
            double a, b, c;
            QString qsResult, qsYs, qsX1s, qsX2s, qsC;

            a = parabola_mx->value();
            b = parabola_bx->value();
            c = parabola_c->value();

            if (a == 0)
            {
                qsResult = "The given equation is <b>not the equation of a parabola</b>! So the TurnPoint can't be found";

            }
            else
            {
                double d = b*b / (4 * a*a) - c / a;	//this might be d = c/a-b*b/(4*a*a)
                if (d > 0)
                {
                    double xs1 = b / (-2*a) + sqrt(d);
                    double xs2 = b / (-2*a) - sqrt(d);
                    qsX1s = qsX1s.number(xs1);
                    qsX2s = qsX2s.number(xs2);
                    qsC = qsC.number(c);
                    qsResult = "The given parabola has the <font color = red><b>two</b></font> intersection-points with the x-axis<br> ";
                    qsResult += "<b>Sx<sub>1</sub>(" + qsX1s + "| 0 )</b> and <b>Sx<sub>1</sub>(" + qsX2s + "| 0 )</b> ";
                    qsResult += "and with the y-axis the intersection-point <b>Sy( 0 |" + qsC+" )</b>.";

                }
                else
                {
                    if (d == 0)
                    {
                        double xs1 = b / (-2*a);
                        qsX1s = qsX1s.number(xs1);
                        qsC = qsC.number(c);
                        qsResult = "The given parabola has only <font color = red><b>one</b></font> intersection-point with the x-axis<br> ";
                        qsResult += "<b>Sx(" + qsX1s + "| 0 )</b>";
                        qsResult += "and with the y-axis the intersection-point<br> <b>Sy( 0 |" + qsC+" )</b>.";

                    }
                    else
                    {
                        qsC = qsC.number(c);
                        qsResult = "The given parabola has <font color = red><b>no</b></font> intersection-point with the x-axis<br> ";
                        if (a > 0)
                        {
                            qsResult += "because it is completely over the x-axis.<br>";
                        }
                        else
                        {
                            qsResult += "because it is completely under the x-axis.<br>";
                        }

                        qsResult += "The intersection-point with the y-axis the intersection-point<br> <b>Sy( 0 |" + qsC+" )</b>.";
                    }
                }
            }
            KTextBrowserResult->setText(qsResult);
            break;
        }


    case ThreePoints: //Find equation of parabola with three given points
        {
            double x1,x2,x3,y1,y2,y3, Det, Deta, Detb, Detc, a, b, c;
            QString qsResult, qsA, qsB, qsC, qsEquation;

            x1 = Point1_x->value();
            y1 = Point1_y->value();
            x2 = Point2_x->value();
            y2 = Point2_y->value();
            x3 = Point3_x->value();
            y3 = Point3_y->value();

            Det = Determinant(x1*x1,x1, 1,x2*x2,x2,1,x3*x3,x3,1);
            if (Det == 0)
            {
                qsResult = "<b>The function determined by the three given points <font color = red>isn't a parabola.</font></b>";
            }
            else
            {
                Deta = Determinant(y1,x1, 1,y2,x2,1,y3,x3,1);
                Detb = Determinant(x1*x1,y1, 1,x2*x2,y2,1,x3*x3,y3,1);
                Detc = Determinant(x1*x1,x1, y1,x2*x2,x2,y2,x3*x3,x3,y3);
                a = Deta / Det;
                if (a == 0)
                {
                    qsResult = "<b>The function determined by the three given points <font color = red>isn't a parabola  but a line.</font></b>";
                }
                else
                {
                    b = Detb / Det;
                    c = Detc / Det;
                    qsA = qsA.number(a);
                    qsB = qsB.number(b);
                    qsC = qsC.number(c);
                    //Formatting the equation
                    qsEquation = qsA + "x <sup>2</sup> ";
                    if (b == 0)
                    {
                        //Nothing to do
                    }
                    else if (b > 0)
                    {
                        qsEquation += "+ " + qsB + "x";
                    }
                    else
                    {
                        qsEquation += qsB + "x";
                    }
                    if (c == 0)
                    {
                        //Nothing to do
                    }
                    else if (c > 0)
                    {
                        qsEquation += "+ " + qsC;
                    }
                    else
                    {
                        qsEquation += qsC;
                    }
                    qsEquation.simplifyWhiteSpace();
                    //End of Formatting
                    qsResult = "The equation of the parabola, that runs through the three given points is:<br>";
                    qsResult += "<b><i>" + qsEquation + "</i></b>.";
                }
            }
            KTextBrowserResult->setText(qsResult);
            break;
        }

    case TurnPointAndPoint: //Find equation of parabola with turnPoint and one point
        {
            double x1,xs,y1,ys, Det, Deta, Detb, Detc, a, b, c;
            QString qsResult, qsA, qsB, qsC, qsEquation;

            x1 = Point1_x->value();
            y1 = Point1_y->value();
            xs = Point2_x->value();
            ys = Point2_y->value();

            Det = Determinant(x1*x1,x1, 1,xs*xs,xs,1,2*xs,1,0);
            if (Det == 0)
            {
                qsResult = "<b>The function determined by the turn point and point <font color = red>isn't a parabola.</font></b>";
                qsResult += "May be the vertex is identical to the second point?";
            }
            else
            {
                Deta = Determinant(y1,x1, 1,ys,xs,1,0,1,0);
                Detb = Determinant(x1*x1,y1, 1,xs*xs,ys,1,2*xs,0,0);
                Detc = Determinant(x1*x1,x1, y1,xs*xs,xs,ys,2*xs,1,0);
                a = Deta / Det;
                if (a == 0)
                {
                    qsResult = "<b>The function determined by the turn point and point <font color = red>isn't a parabola  but a line.</font></b>";
                }
                else
                {
                    b = Detb / Det;
                    c = Detc / Det;
                    qsA = qsA.number(a);
                    qsB = qsB.number(b);
                    qsC = qsC.number(c);
                    //Formatting the equation
                    qsEquation = qsA + "x <sup>2</sup> ";
                    if (b == 0)
                    {
                        //Nothing to do
                    }
                    else if (b > 0)
                    {
                        qsEquation += "+ " + qsB + "x";
                    }
                    else
                    {
                        qsEquation += qsB + "x";
                    }
                    if (c == 0)
                    {
                        //Nothing to do
                    }
                    else if (c > 0)
                    {
                        qsEquation += "+ " + qsC;
                    }
                    else
                    {
                        qsEquation += qsC;
                    }
                    qsEquation.simplifyWhiteSpace();
                    //End of Formatting
                    qsResult = "The equation of the parabola, that runs through the turn point and point is:<br>";
                    qsResult += "Y =<b><i>" + qsEquation + "</i></b>.";
                }
            }
            KTextBrowserResult->setText(qsResult);
            break;
        }

    case Intersect_Parabola_Line: //Find intersection point of parabola and line
        {
            double a, b, c, m, d, Dis, xs1, xs2, ys1,ys2;
            QString qsResult, qsYs1, qsXs1, qsYs2, qsXs2;

            //parabola values
            a = parabola_mx->value();
            b = parabola_bx->value();
            c = parabola_c->value();
            //line values
            m = Line_mx->value();
            d = Line_c->value();

            Dis = ((b - m)*(b - m)/(4*a*a)) - (( c- d)/a);
            if ( Dis < 0 )
            {
                //No intersection
                qsResult = "The given parabola and line <font color = red>do no intersect!</font>.";
            }
            else if (Dis == 0)
            {
                //one intersection point
                xs1 = -(b - m)/(2*a);
                ys1 = m*xs1+d;

                qsXs1 = qsXs1.number(xs1);
                qsYs1 = qsYs1.number(ys1);

                qsResult = "There is <b>one intersection-point</b> of the parabola and the line at <br>";
                qsResult += "<b><i>S(" + qsXs1 + "|" + qsYs1 + ")</i></b> .<br>";
                qsResult += "So the line is a <b>tangent</b> to the parabola.";
            }
            else
            {
                //two intersection points
                xs1 = -(b - m)/(2*a) + sqrt(Dis);
                xs2 = -(b - m)/(2*a) - sqrt(Dis);
                ys1 = m*xs1+d;
                ys2 = m*xs2+d;

                qsXs1 = qsXs1.number(xs1);
                qsYs1 = qsYs1.number(ys1);
                qsXs2 = qsXs2.number(xs2);
                qsYs2 = qsYs2.number(ys2);

                qsResult = "There is <b>two intersection-points</b> of the parabola and the line at <br>";
                qsResult += "<b><i>S<sub>1</sub>(" + qsXs1 + "|" + qsYs1 + ")</i></b> and <b><i>S<sub>2</sub>(" + qsXs2 + "|" + qsYs2 + ")</i></b>.<br>";
                qsResult += "So the line and the parabola do <b>intersect</b>.";
            }
            KTextBrowserResult->setText(qsResult);
            break;
        }

    case Intersect_Parabola_Parabola: //Find intersection point of two parabolas
        {
            double a, b, c,d,e,f, Dis, xs1, xs2, ys1,ys2;
            QString qsResult, qsYs1, qsXs1, qsYs2, qsXs2;

            //parabola 1
            a = parabola_mx->value();
            b = parabola_bx->value();
            c = parabola_c->value();
            //parabola 2
            d = parabola2_mx->value();
            e = parabola2_bx->value();
            f = parabola2_c->value();

            Dis = (b- e)*(b-e)/(2*(a-d)*(a-d))-((c-f)/(a-d));
            if ( Dis < 0 )
            {
                //No intersection
                qsResult = "The two given parabolas <font color = red>do no intersect!</font>.";
            }
            else if (Dis == 0)
            {
                //one intersection point
                xs1 = - (b - e)/(2*(a-d));
                ys1 = a*xs1*xs1+b*xs1+c;

                qsXs1 = qsXs1.number(xs1);
                qsYs1 = qsYs1.number(ys1);

                qsResult = "There is <b>one intersection-point</b> of the two parabolas at<br>";
                qsResult += "<b><i>S(" + qsXs1 + "|" + qsYs1 + ")</i></b> .<br>";
                qsResult += "So the two parabolas are <b>tangent</b> to each other at the intersection point.";
            }
            else
            {
                //two intersection points
                xs1 = - (b - e)/(2*(a-d)) + sqrt(Dis);
                xs2 = - (b - e)/(2*(a-d)) - sqrt(Dis);
                ys1 = a*xs1*xs1+b*xs1+c;
                ys2 = a*xs2*xs2+b*xs2+c;

                qsXs1 = qsXs1.number(xs1);
                qsYs1 = qsYs1.number(ys1);
                qsXs2 = qsXs2.number(xs2);
                qsYs2 = qsYs2.number(ys2);

                qsResult = "There is <b>two intersection-points</b> of the two parabolas at <br>";
                qsResult += "<b><i>S<sub>1</sub>(" + qsXs1 + "|" + qsYs1 + ")</i></b> and <b><i>S<sub>2</sub>(" + qsXs2 + "|" + qsYs2 + ")</i></b>.<br>";
                qsResult += "So the line and the parabola do <b>intersect</b>.";
            }
            KTextBrowserResult->setText(qsResult);
            break;
        }
    }
}

void Parabolas::slotClear()
{
    KTextBrowserResult->setText("");

    Point1_x->setValue(0);
    Point1_y->setValue(0);
    Point2_x->setValue(0);
    Point2_y->setValue(0);
    Point3_x->setValue(0);
    Point3_y->setValue(0);
    Line_mx->setValue(0);
    Line_c->setValue(0);
    parabola_mx->setValue(0);
    parabola_bx->setValue(0);
    parabola_c->setValue(0);
    parabola2_mx->setValue(0);
    parabola2_bx->setValue(0);
    parabola2_c->setValue(0);

}


void Parabolas::slotShowParabolaAxisSection()  //find X-Y axis cuts of equation
{
    clearBoxes();

    TextLabelInformation->setText(i18n("Find intersection with X & Y axis"));
    KTextBrowserResult->setText("");

    parabola_mx->show();
    parabola_bx->show();
    parabola_c->show();
    parabolaEquation1->show();
    x1->show();
    X1->show();

    m_eSelected = AxisSection;
}



void Parabolas::slotShowParabola3Points() //Find equation with 3 points
{
    clearBoxes();

    TextLabelInformation->setText(i18n("Find equation with three points"));
    KTextBrowserResult->setText("");

    Point1_x->show();
    Point1_y->show();
    Point2_x->show();
    Point2_y->show();
    Point3_x->show();
    Point3_y->show();

    point1->show();
    textLabel3->show();
    textLabel2->show();
    pointformat1->show();
    point2->show();
    textLabel3_2->show();
    textLabel2_2->show();
    pointformat2->show();
    point3->show();
    textLabel3_2_2->show();
    textLabel2_3->show();
    pointformat3->show();

    m_eSelected = ThreePoints;
}



void Parabolas::slotShowParabolaPointandTurnPoint()
{
    clearBoxes();

    TextLabelInformation->setText(i18n("Find equation with the TurnPoint and point"));
    point1->setText(i18n("TurnPoint S:"));
    point2->setText (i18n("one Point :"));

    Point1_x->show();
    Point1_y->show();
    Point2_x->show();
    Point2_y->show();

    point1->show();
    textLabel3->show();
    textLabel2->show();
    pointformat1->show();
    point2->show();
    textLabel3_2->show();
    textLabel2_2->show();
    pointformat2->show();

    KTextBrowserResult->setText("");
    m_eSelected = TurnPointAndPoint;
}


void Parabolas::slotShowParabolaFindTurnPoint()
{
    clearBoxes();

    TextLabelInformation->setText(i18n("Find the TurnPoint of a parabola"));

    parabola_mx->show();
    parabola_bx->show();
    parabola_c->show();

    parabolaEquation1->show();
    x1->show();
    X1->show();

    KTextBrowserResult->setText("");
    m_eSelected = TurnPoint;
}

void Parabolas::slotShowParabolaLineSection()
{
    clearBoxes();

    TextLabelInformation->setText(i18n("Find intersect(s) porabola and line"));

    Line_mx->show();
    Line_c->show();
    parabola_mx->show();
    parabola_bx->show();
    parabola_c->show();

    lineEquation->show();
    textLabel6->show();
    lineFormat->show();
    parabolaEquation1->show();
    x1->show();
    X1->show();

    parabolaFormat->show();

    KTextBrowserResult->setText("");
    m_eSelected = Intersect_Parabola_Line;
}

void Parabolas::slotShowParabolaParabola()
{
    clearBoxes();

    TextLabelInformation->setText(i18n("Find intersect(s) of two parabolas"));

    parabola_mx->show();
    parabola_bx->show();
    parabola_c->show();
    parabola2_mx->show();
    parabola2_bx->show();
    parabola2_c->show();

    parabolaEquation1->show();
    x1->show();
    X1->show();
    parabolaEquation2->show();
    x2->show();
    X2->show();
    parabolaFormat->show();

    KTextBrowserResult->setText("");
    m_eSelected = Intersect_Parabola_Parabola;
}

void Parabolas::clearBoxes()
{	//Clear Boxes
    KTextBrowserResult->setText("");

    Point1_x->setValue(0);
    Point1_y->setValue(0);
    Point2_x->setValue(0);
    Point2_y->setValue(0);
    Point3_x->setValue(0);
    Point3_y->setValue(0);
    Line_mx->setValue(0);
    Line_c->setValue(0);
    parabola_mx->setValue(0);
    parabola_bx->setValue(0);
    parabola_c->setValue(0);
    parabola2_mx->setValue(0);
    parabola2_bx->setValue(0);
    parabola2_c->setValue(0);

    Point1_x->hide();
    Point1_y->hide();
    Point2_x->hide();
    Point2_y->hide();
    Point3_x->hide();
    Point3_y->hide();
    Line_mx->hide();
    Line_c->hide();
    parabola_mx->hide();
    parabola_bx->hide();
    parabola_c->hide();
    parabola2_mx->hide();
    parabola2_bx->hide();
    parabola2_c->hide();

    point1->hide();
    textLabel3->hide();
    textLabel2->hide();
    pointformat1->hide();
    point2->hide();
    textLabel3_2->hide();
    textLabel2_2->hide();
    pointformat2->hide();
    point3->hide();
    textLabel3_2_2->hide();
    textLabel2_3->hide();
    pointformat3->hide();
    lineEquation->hide();
    textLabel6->hide();
    lineFormat->hide();
    parabolaEquation1->hide();
    x1->hide();
    X1->hide();
    parabolaEquation2->hide();
    x2->hide();
    X2->hide();
    parabolaFormat->hide();

}

double Parabolas::Determinant(double d11,double d12, double d13, double d21, double d22, double d23, double d31, double d32, double d33)
{
    double Det = d11*d22*d33+d12*d23*d31+d13*d21*d32-d31*d22*d13-d32*d23*d11-d33*d21*d12;
    return Det;
}
