
#include "kmathvistrig_part.h"

#include <kinstance.h>

#include "trigviewer.h"


KMathVisTrigPart::KMathVisTrigPart( QWidget *parentWidget, const char *widgetName,
                                  QObject *parent, const char *name )
    : KParts::ReadOnlyPart(parent, name)
{
    setInstance( KMathVisTrigPartFactory::instance() );

    m_widget = new TrigViewer( parentWidget, widgetName );

    setWidget(m_widget);

    setXMLFile("kmathvistrig_part.rc");
}

KMathVisTrigPart::~KMathVisTrigPart()
{
}

bool KMathVisTrigPart::openFile()
{
    return false;
}

// It's usually safe to leave the factory code alone.. with the
// notable exception of the KAboutData data
#include <kaboutdata.h>
#include <klocale.h>

KInstance*  KMathVisTrigPartFactory::s_instance = 0L;
KAboutData* KMathVisTrigPartFactory::s_about = 0L;

KMathVisTrigPartFactory::KMathVisTrigPartFactory()
    : KParts::Factory()
{
}

KMathVisTrigPartFactory::~KMathVisTrigPartFactory()
{
    delete s_instance;
    delete s_about;

    s_instance = 0L;
}

KParts::Part* KMathVisTrigPartFactory::createPartObject( QWidget *parentWidget, const char *widgetName,
                                                        QObject *parent, const char *name,
                                                        const char *classname, const QStringList &args )
{
    // Create an instance of our Part
    KMathVisTrigPart* obj = new KMathVisTrigPart( parentWidget, widgetName, parent, name );
    return obj;
}

KInstance* KMathVisTrigPartFactory::instance()
{
    if( !s_instance )
    {
        s_about = new KAboutData("kmathvistrigpart", I18N_NOOP("KMathVisTrigPart"), "0.1");
        s_about->addAuthor("Trenton Carr", 0, "trentoncarr@telkomsa.net");
        s_instance = new KInstance(s_about);
    }
    return s_instance;
}

extern "C"
{
    void* init_libkmathvistrigpart()
    {
        return new KMathVisTrigPartFactory;
    }
};

#include "kmathvistrig_part.moc"
