
#ifndef _KMATHVISTRIGPART_H_
#define _KMATHVISTRIGPART_H_

#include <kparts/part.h>
#include <kparts/factory.h>

class QWidget;
class QPainter;
class KURL;

class TrigViewer;

/**
 * @author Trenton Carr <trentoncarr@telkomsa.net>
 * @version 0.1
 */
class KMathVisTrigPart : public KParts::ReadOnlyPart
{
    Q_OBJECT
public:
    /**
     * Default constructor
     */
    KMathVisTrigPart(QWidget *parentWidget, const char *widgetName,
                    QObject *parent, const char *name);

    /**
     * Destructor
     */
    virtual ~KMathVisTrigPart();

protected:
    /**
     * This must be implemented by each part
     */
    virtual bool openFile();

private:
    TrigViewer *m_widget;
};

class KInstance;
class KAboutData;

class KMathVisTrigPartFactory : public KParts::Factory
{
    Q_OBJECT
public:
    KMathVisTrigPartFactory();
    virtual ~KMathVisTrigPartFactory();
    virtual KParts::Part* createPartObject( QWidget *parentWidget, const char *widgetName,
                                            QObject *parent, const char *name,
                                            const char *classname, const QStringList &args );
    static KInstance* instance();
 
private:
    static KInstance* s_instance;
    static KAboutData* s_about;
};

#endif // _KMATHVISTRIGPART_H_
