/***************************************************************************
 *   Copyright (C) 2004 by Trenton Carr                                    *
 *   trentoncarr@telkomsa.net                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _KTRIGPLOTWIDGET_H_
#define _KTRIGPLOTWIDGET_H_

#include <qwidget.h>
#include "kplotwidget.h"

class QColor;
class QPixmap;

/**@class KTrigPlotWidget
	*@short A Trig plotting widget for KMathTool, derived from the more generic class KPlotWidget.
	*@author Trenton Carr
	*@version 1.0
	*Widget for drawing Trig Ratios. 
	*/

class KTrigPlotWidget : public KPlotWidget
{
    Q_OBJECT
public:
    /**Constructor
    	*/
    KTrigPlotWidget( double x1=0.0, double x2=1.0, double y1=0.0, double y2=1.0, QWidget *parent=0, const char* name=0 );

    /**Destructor (empty)
    	*/
    ~KTrigPlotWidget()
    {}

    /**@short toggle whether Cartesian Trig axes are drawn.
    *@param show if true, axes will be drawn.
    *The axes cut through (0,0).
    */
    virtual void setShowCartTrigAxes( bool show )
    {
        ShowCartTrigAxes = show;
    }
    /**@short toggle whether tick marks are drawn along the Cartesian Trig axes.
    	*@param show if true, tick marks will be drawn.
    	*/
    virtual void setShowCartTrigTickMarks( bool show )
    {
        ShowCartTrigTickMarks = show;
    }


protected:
    void drawBox( QPainter *p );
    bool ShowCartTrigAxes, ShowCartTrigTickMarks;

};

#endif
