/***************************************************************************
 *   Copyright (C) 2004 by Trenton Carr                                    *
 *   trentoncarr@telkomsa.net                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TRIGVIEWER_H
#define TRIGVIEWER_H

#include <qwidget.h>

class KTrigPlotWidget;

/**@class TrigViewer
	*@short Display a Trig Cartesian Plane
	*@version 1.0
	*@author Trenton Carr
	*/

class TrigViewer : public QWidget
{
    Q_OBJECT

public:
    TrigViewer(QWidget* parent = 0, const char* name = 0 );
    ~TrigViewer();
    /*$PUBLIC_FUNCTIONS$*/

public slots:
    /*$PUBLIC_SLOTS$*/


protected:
    /*$PROTECTED_FUNCTIONS$*/
    virtual void paintEvent( QPaintEvent* );

protected slots:
    /*$PROTECTED_SLOTS$*/


private:
    void drawObjects();
    KTrigPlotWidget *pw;
    QWidget *view;
    double deg_theta;
};


#endif

