
#include "kmathtool_part.h"
#include "startwidgetview.h"

#include <kinstance.h>

KMathToolPart::KMathToolPart( QWidget *parentWidget, const char *widgetName,
                              QObject *parent, const char *name )
    : KParts::ReadOnlyPart(parent, name)
{
  // we need an instance
  setInstance( KMathToolPartFactory::instance() );

  m_kmstart = new StartWidgetView(parentWidget,widgetName);
  
  m_kmstart->show();

  setXMLFile("kmathtool_part.rc");
}

KMathToolPart::~KMathToolPart()
{}

bool KMathToolPart::openFile()
{
  return false;
}


// It's usually safe to leave the factory code alone.. with the
// notable exception of the KAboutData data
#include <kaboutdata.h>
#include <klocale.h>

KInstance*  KMathToolPartFactory::s_instance = 0L;
KAboutData* KMathToolPartFactory::s_about = 0L;

KMathToolPartFactory::KMathToolPartFactory()
    : KParts::Factory()
{}

KMathToolPartFactory::~KMathToolPartFactory()
{
  delete s_instance;
  delete s_about;

  s_instance = 0L;
}

KParts::Part* KMathToolPartFactory::createPartObject( QWidget *parentWidget, const char *widgetName,
    QObject *parent, const char *name,
    const char *classname, const QStringList &args )
{
  // Create an instance of our Part
  KMathToolPart* obj = new KMathToolPart( parentWidget, widgetName, parent, name );
  return obj;
}

KInstance* KMathToolPartFactory::instance()
{
  if( !s_instance )
  {
    s_about = new KAboutData("kmathtoolpart", I18N_NOOP("KMathToolPart"), "0.3");
    s_about->addAuthor("Trenton Carr", 0, "trentoncarr@telkomsa.net");
    s_instance = new KInstance(s_about);
  }
  return s_instance;
}

extern "C"
{
  void* init_libkmathtoolpart()
  {
    return new KMathToolPartFactory;
  }
};

#include "kmathtool_part.moc"
