
#ifndef _KMATHTOOLPART_H_
#define _KMATHTOOLPART_H_

#include <kparts/part.h>
#include <kparts/factory.h>

class QWidget;
class QPainter;
class KURL;

class StartWidgetView;

/**
 * @author Trenton Carr <trentoncarr@telkomsa.net>
 * @version 0.3
 */
class KMathToolPart : public KParts::ReadOnlyPart
{
  Q_OBJECT
public:
  KMathToolPart(QWidget *parentWidget, const char *widgetName,
                QObject *parent, const char *name);

  virtual ~KMathToolPart();

protected:
  virtual bool openFile();

private:
  StartWidgetView *m_kmstart;
};

class KInstance;
class KAboutData;

class KMathToolPartFactory : public KParts::Factory
{
  Q_OBJECT
public:
  KMathToolPartFactory();
  virtual ~KMathToolPartFactory();
  virtual KParts::Part* createPartObject( QWidget *parentWidget, const char *widgetName,
                                          QObject *parent, const char *name,
                                          const char *classname, const QStringList &args );
  static KInstance* instance();

private:
  static KInstance* s_instance;
  static KAboutData* s_about;
};

#endif // _KMATHTOOLPART_H_
