/***************************************************************************
 *   Copyright (C) 2004 by Trenton Carr                                    *
 *   trentoncarr@mweb.co.za                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "startwidgetview.h"

#include <qtabwidget.h>
#include <qwidget.h>

#include <kmessagebox.h>
#include <klibloader.h>
#include <klocale.h>


StartWidgetView::StartWidgetView(QWidget* parent, const char* name, WFlags fl)
    : StartWidgetD(parent,name,fl)
{
  m_parea = new QWidget;
  m_pfactor = new QWidget;
  m_pline = new QWidget;
  m_pparabola = new QWidget;
  m_pvistrig = new QWidget;
  

  //*************************************************************************************//
  KLibFactory *factory = KLibLoader::self()->factory( "libkmathareaperimeterpart" );
  if (factory)
  {
    m_kmarea = (KParts::ReadOnlyPart *)factory->create(m_parea ,
              "kmathareaperimeterpart", "KParts::ReadOnlyPart" );
  }

  else
  {
    KMessageBox::error(this, i18n("Could not find our part."));
    return;
  }

  //*************************************************************************************//
  factory = KLibLoader::self()->factory( "libkmathfactorpart" );
  if (factory)
  {
    m_kmfactor = (KParts::ReadOnlyPart *)factory->create( m_pfactor,
                "kmathfactorpart", "KParts::ReadOnlyPart" );
  }

  else
  {
    KMessageBox::error(this, i18n("Could not find our part."));
    return;
  }

  //*************************************************************************************//
  factory = KLibLoader::self()->factory( "libkmathlinepart" );
  if (factory)
  {
    m_kmline = (KParts::ReadOnlyPart *)factory->create( m_pline,
              "kmathlinepart", "KParts::ReadOnlyPart" );
  }

  else
  {
    KMessageBox::error(this, i18n("Could not find our part."));
    return;
  }

  //*************************************************************************************//
  factory = KLibLoader::self()->factory( "libkmathparabolapart" );
  if (factory)
  {
    m_kmparabola = (KParts::ReadOnlyPart *)factory->create( m_pparabola,
                  "kmathparabolapart", "KParts::ReadOnlyPart" );
  }

  else
  {
    KMessageBox::error(this, i18n("Could not find our part."));
    return;
  }
  //*************************************************************************************//
  factory = KLibLoader::self()->factory( "libkmathvistrigpart" );
  if (factory)
  {
    m_kmvistrig = (KParts::ReadOnlyPart *)factory->create( m_pvistrig,
                  "kmathvistrigpart", "KParts::ReadOnlyPart" );
  }

  else
  {
    KMessageBox::error(this, i18n("Could not find our part."));
    return;
  }

  tabWidget->insertTab( m_parea, QString("Area + Perimeter") );
  tabWidget->insertTab( m_pfactor, QString("Factors") );
  tabWidget->insertTab( m_pline, QString("Lines") );
  tabWidget->insertTab( m_pparabola , QString("Parabolas") );
  tabWidget->insertTab( m_pvistrig, QString("Vis Trig") );
}

StartWidgetView::~StartWidgetView()
{}


#include "startwidgetview.moc"
